VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Display"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'ftHg̐ݒ
Private OldMode As DEVMODE
'ݒ胊Xg
Private ModeList(1000) As DEVMODE
'ݒ胊Xg̐
Private DisplayModeNumber As Integer

'fBXvC̕擾
'p[^    n As Integer
'߂l        nԖڂ̐ݒ̕
'               nȗꍇ݂̃fBXvC̕Ԃ
Public Function GetWidth(Optional n As Integer = -1) As Integer
    If n >= 0 And n < GetDisplayModeNumber Then
        GetWidth = ModeList(n).dmPelsWidth
    ElseIf n = -1 Then
        Dim DesktopDC As Long
        Dim ret As Long
        DesktopDC = GetDC(0)
        GetWidth = GetDeviceCaps(DesktopDC, HORZRES)
        ret = ReleaseDC(0, DesktopDC)
    End If
End Function

'fBXvC̍擾
'p[^    n As Integer
'߂l        nԖڂ̐ݒ̍
'               nȗꍇ݂̃fBXvC̍Ԃ
Public Function GetHeight(Optional n As Integer = -1) As Integer
    If n >= 0 And n < GetDisplayModeNumber Then
        GetHeight = ModeList(n).dmPelsHeight
    ElseIf n = -1 Then
        Dim DesktopDC As Long
        Dim ret As Long
        DesktopDC = GetDC(0)
        GetHeight = GetDeviceCaps(DesktopDC, VERTRES)
        ret = ReleaseDC(0, DesktopDC)
    End If
End Function

'fBXvC̐F[x擾
'p[^    n As Integer
'߂l        nԖڂ̐ݒ̐F[x
'               nȗꍇ݂̃fBXvC̐F[xԂ
Public Function GetBit(Optional n As Integer = -1) As Integer
    If n >= 0 And n < GetDisplayModeNumber Then
        GetBit = ModeList(n).dmBitsPerPel
    ElseIf n = -1 Then
        Dim DesktopDC As Long
        Dim ret As Long
        DesktopDC = GetDC(0)
        GetBit = GetDeviceCaps(DesktopDC, BITSPIXEL)
        ret = ReleaseDC(0, DesktopDC)
    End If
End Function

'ύXłfBXvC[h
'p[^    Ȃ
'߂l        ύXłfBXvC[h̐
Public Function GetDisplayMode() As Integer
    DisplayModeNumber = 0
    Do
        If (EnumDisplaySettings(vbNullString, DisplayModeNumber, ModeList(DisplayModeNumber))) = 0 Then Exit Do
        If CheckNowSetting(ModeList(DisplayModeNumber)) Then
            OldMode = ModeList(DisplayModeNumber)
        End If
        DisplayModeNumber = DisplayModeNumber + 1
    Loop
    GetDisplayMode = DisplayModeNumber
End Function

'fBXvC[hύX
'p[^    n As Integer , w As Integer , h As Integer , b As Integer
'nԖڂ̐ݒɕύXB
'nȗꍇAwAhAF[xbƂĕύXB
'SďȗꍇAftHg̐ݒɕύXB
'߂l        DISP_CHANGE_SUCCESSFULA
Public Function ChangeDisplayMode(Optional n As Integer = -1, Optional w As Integer, Optional h As Integer, Optional b As Integer) As Long
    If n >= 0 And n < GetDisplayModeNumber Then
        If ChangeDisplaySettings(ModeList(n), CDS_TEST) = DISP_CHANGE_SUCCESSFUL Then
            ChangeDisplayMode = ChangeDisplaySettings(ModeList(n), 0)
        Else
            ChangeDisplayMode = 0
        End If
    ElseIf w = 0 And h = 0 And b = 0 Then
        If CheckNowSetting(OldMode) Then
            ChangeDisplayMode = 0
        Else
            If ChangeDisplaySettings(OldMode, CDS_TEST) = DISP_CHANGE_SUCCESSFUL Then
                ChangeDisplayMode = ChangeDisplaySettings(OldMode, 0)
            Else
                ChangeDisplayMode = 0
            End If
        End If
    Else
        Dim i As Integer
        For i = 0 To GetDisplayModeNumber
            If GetWidth(i) = w And GetHeight(i) = h And GetBit(i) = b Then
                ChangeDisplayMode = ChangeDisplayMode(i)
                Exit Function
            End If
        Next i
        ChangeDisplayMode = 0
    End If
End Function

'ύXłfBXvC[h̐
'p[^    Ȃ
'߂l        ύXłfBXvC[h̐
Public Function GetDisplayModeNumber() As Integer
    GetDisplayModeNumber = DisplayModeNumber
End Function

'ł̂ݎgp
Private Function CheckNowSetting(d As DEVMODE) As Boolean
    CheckNowSetting = (d.dmBitsPerPel = GetBit()) And _
                      (d.dmPelsWidth = GetWidth()) And _
                      (d.dmPelsHeight = GetHeight())
End Function

'
Private Sub Class_Initialize()
    GetDisplayMode
End Sub

'jƂɌĂяo
Private Sub Class_Terminate()
    ChangeDisplayMode
End Sub
